#include "ili_cache.h"



//														
CompressedKey::CompressedKey (void)
{
	i_CompressedLength = 0;
	p_Data = NULL;
}


//														
CompressedKey::CompressedKey (const CompressedKey& _rKey)
{
	i_CompressedLength = _rKey.i_CompressedLength;
	if (0 == i_CompressedLength)
	{
		p_Data = NULL;
		return;
	}
	p_Data = (char*)malloc (i_CompressedLength);
	memcpy (p_Data, _rKey.p_Data, i_CompressedLength);
}


//														
CompressedKey::CompressedKey (const String& _rString)
{
	i_CompressedLength = 0;
	p_Data = NULL;
	ZlibWrapper::Compress (_rString, &p_Data, &i_CompressedLength);
}


//														
CompressedKey::~CompressedKey (void)
{
	assert ((char*)0x1 != p_Data);
	if (NULL != p_Data)
		free (p_Data);
	p_Data = (char*)0x1;
	i_CompressedLength = -1;
}


//														
bool CompressedKey::operator< (const CompressedKey& _rRight) const
{
	int iMinLength = (i_CompressedLength < _rRight.i_CompressedLength)?
					  i_CompressedLength : _rRight.i_CompressedLength;
	int iCmp = memcmp (p_Data, _rRight.p_Data, iMinLength);
	if (iCmp < 0)
		return true;
	else if (iCmp > 0)
		return false;
	return (i_CompressedLength < _rRight.i_CompressedLength);
}


//														
bool CompressedKey::operator== (const CompressedKey& _rRight) const
{
	if (i_CompressedLength != _rRight.i_CompressedLength)
		return false;

	return (0 == memcmp (p_Data, _rRight.p_Data, i_CompressedLength));
}


