#include "ili_cache.h"
#include <nlp_macros.h>

typedef deque <char*>	zchar_dq_t;

size_t	EnvObject::i_ObjectMemorySize = 0;


//															
EnvObject::EnvObject (void)
{
	z_ID [0] = '\0';
}


//															
EnvObject::EnvObject (char* _zData)
{
	z_ID [0] = '\0';
	SetData (_zData);
}


//															
EnvObject::~EnvObject (void)
{
}


//															
void EnvObject::SetData (char* _zData)
{
	assert ('\0' == z_ID [0]);

	// id, mainwnd_id, activationwnd_id, temporally_uniq_id, name, class, features	
	// s_ObjectData = _zData;
	// String sCopy (_zData);

	// zchar_dq_t dqValues = String::DestructiveSplit (_zData, '\x01', 3);
	zchar_dq_t dqValues = String::DestructiveSplit (_zData, '\x01', 6);
	// s_ID = dqValues [0];
	// s_ID.Strip ();
	String sID (dqValues [0]);
	sID.Strip ();
	if (sID.length () >= 24)
	{
		cerr << "[ERROR] environment object data has id longer than 24 characters.\n"
			 << sID << endl;
		abort ();
	}
	strcpy (z_ID, sID);

	// s_Features = dqValues [3];
	// s_Features = s_Features.substr (s_Features.Find ("\x04"));
	s_TemporallyUniqueId = dqValues [3];
	s_TemporallyUniqueId = s_TemporallyUniqueId.substr (s_TemporallyUniqueId.Find ("\x04"));

	// split out feature values ...
	// bit_Features.SetFeatures (dqValues [3]);
	bit_Features.SetFeatures (dqValues [6]);

	// #define FEATURES_TO_SKIP	3
	// zchar_dq_t dqFeatures = String::DestructiveSplit (dqValues [3], '\x01');
	// if (23 != dqFeatures.size ())
	// 	cout << "features : " << dqFeatures.size () << '\n'
	// 		 << "->" << sCopy << "<-" << endl;
	// assert (23 == dqFeatures.size ());
	// int iFeatures = dqFeatures.size () - FEATURES_TO_SKIP;
	// vec_Features.Create (iFeatures);
	// for (int i = 0; i < iFeatures; ++ i)
	// 	vec_Features [i] = (char) atoi (dqFeatures [i + FEATURES_TO_SKIP]);
}


//															
/*
EnvObject_dq_t EnvObject::UnpackState (String& _rState)
{
	String sCopy (_rState);
	sCopy.Replace ("\x10", "");
	zchar_dq_t dqRawObjects = sCopy.DestructiveSplit ('\x03');

	EnvObject_dq_t dqObjects;
	ITERATE (zchar_dq_t, dqRawObjects, ite)
	{
		if ('\0' == **ite)
			continue;
		if (NULL == strchr (*ite, '\x01'))
			continue;
		dqObjects.push_back (new EnvObject (*ite));
	}

	return dqObjects;
}
*/


//															
void EnvObject::UnpackState (String& _rState, void** _ppObjects, int* _pObjectCount)
{
	String sCopy (_rState);
	sCopy.Replace ("\x10", "");
	zchar_dq_t dqRawObjects = sCopy.DestructiveSplit ('\x03');

	int iCount = 0;
	ITERATE (zchar_dq_t, dqRawObjects, ite)
	{
		if ('\0' == **ite)
			continue;
		if (NULL == strchr (*ite, '\x01'))
			continue;
		++ iCount;
	}

	*_pObjectCount = iCount;
	if (0 == iCount)
	{
		*_ppObjects = NULL;
		return;
	}

	EnvObject* pObjects = new EnvObject [iCount];
	*_ppObjects = pObjects;

	iCount = 0;
	ITERATE (zchar_dq_t, dqRawObjects, ite)
	{
		if ('\0' == **ite)
			continue;
		if (NULL == strchr (*ite, '\x01'))
			continue;
		pObjects [iCount].SetData (*ite);
		++ iCount;
	}
}


//															
void EnvObject::DestroyObjects (void* _pObjects)
{
	EnvObject* pObjects = (EnvObject*) _pObjects;
	delete[] pObjects;
}



