#include "ili_cache.h"



//																
void ZlibWrapper::Compress (const String& _rState,
							char** _ppBuffer,
							int* _pCompressedLength)
{
	int iLength = _rState.length ();
	uLongf iCompressedLength = (uLongf) ceil (12 + 1.1 * iLength);
	char pCompressed [iCompressedLength];

	#ifndef NDEBUG
	int iRet = 
	#endif
		compress2 ((Bytef*)pCompressed, 
				  &iCompressedLength, 
				  (const Bytef*)(const char*)_rState, 
				  iLength + 1,
				  9);
	assert (Z_OK == iRet);

	*_pCompressedLength = iCompressedLength;
	*_ppBuffer = new char [iCompressedLength];
	memcpy (*_ppBuffer, pCompressed, iCompressedLength);
}



//																
String ZlibWrapper::Uncompress (const char* _pCompressed, 
								int _iCompressedLength,
								int _iUncompressedLength)
{
	char pUncompressed [_iUncompressedLength];
	uLongf iUncompressedLength = _iUncompressedLength;
	#ifndef NDEBUG
	int iRet = 
	#endif
		uncompress ((Bytef*) pUncompressed, 
					&iUncompressedLength,
					(Bytef*) _pCompressed,
					_iCompressedLength);
	assert (Z_OK == iRet);
	assert (iUncompressedLength == (uLongf)_iUncompressedLength);

	String sUncompressed;
	sUncompressed = pUncompressed;
	return sUncompressed;
}




