import sys, os, socket, time, re


soc_Client = None
rgx_Whitespace = re.compile ('[ \t]+')
rgx_WhitespaceNoTab = re.compile ('[ ]+')
rgx_NonAlnum = re.compile ('[^a-zA-Z0-9]+')
lstObjects = None


#																	
raw_OBJECT_ID				= 0
raw_MAIN_WND_ID				= 1
raw_ACT_WND_ID				= 2
raw_OBJECT_NAME				= 3
raw_OBJECT_CLASS			= 4
raw_FAMILY_TOUCHED			= 5
raw_OBJECT_TOUCHED			= 6
raw_MAIN_WND_TOUCHED		= 7
raw_ACT_WND_TOUCHED			= 8
raw_NAME_CHANGED			= 9
raw_NAME_EDIT_DIST			= 10
raw_VISIBLE					= 11
raw_NEWLY_VISIBLE			= 12
raw_SHOWING					= 13
raw_NEWLY_SHOWING			= 14
raw_INFOCUS					= 15
raw_NEWLY_INFOCUS			= 16
raw_FG						= 17
raw_NEWLY_FG				= 18
raw_INPUT_ENABLED			= 19
raw_NEWLY_INPUT_ENABLED		= 20
raw_SELECTED				= 21
raw_NEWLY_SELECTED			= 22
raw_CHILD					= 23
raw_NEW						= 24
raw_MESSAGE_LENGTH			= 25



# --------------------------------------------------------------
class Object:
	def __init__ (self):
		self.i_Index = None
		self.s_ID = ''
		self.s_MainWndID = ''
		self.s_ActivationWndID = ''
		self.s_Name = ''
		self.s_CleanName = ''
		self.i_ObjectClass = 0
		self.s_ObjectClass = ''
		self.v_RawFeatures = []
		self.d_ReplyFeatures = []



#																	
def measure_state (sLine):
	global lstObjects

	# ask for state of system ...		
	sCommand = sLine
	soc_Client.send (sCommand + '\n')
	sResponse = ''
	while '\x10' not in sResponse:
		sResponse = sResponse + soc_Client.recv (1024)
	
	sResponse = sResponse.lower ()

	# extract objects from response ...	
	lstObjects = []
	bHasVisibleObjects = False
	iObjectIndex = 0

	lstRawObjects = sResponse.split ('\x03')
	for sRawObject in lstRawObjects:
		sRawObject = sRawObject.strip ()
		if '' == sRawObject:
			continue
		if '\x10' in sRawObject:
			continue

		# exception protection against message corruption during transmission ...
		if len (sRawObject.split ('\x01')) != raw_MESSAGE_LENGTH:
			continue

		fvRawObject = [None] * raw_MESSAGE_LENGTH
		for i, x in enumerate (sRawObject.split ('\x01')):
			fvRawObject [i] = x.strip ()
		if (len (fvRawObject) != raw_MESSAGE_LENGTH):
			print '[ERROR] in measure_state, length of received object feature vector ['\
										+ str (len (fvRawObject)) + '] is not expected value ['\
										+ str (raw_MESSAGE_LENGTH)
		assert (len (fvRawObject) == raw_MESSAGE_LENGTH)

		oObject = Object ()
		oObject.i_Index = iObjectIndex
		oObject.s_ID = fvRawObject [raw_OBJECT_ID]
		oObject.s_MainWndID = fvRawObject [raw_MAIN_WND_ID]
		oObject.s_ActivationWndID = fvRawObject [raw_ACT_WND_ID]
		oObject.s_Name = fvRawObject [raw_OBJECT_NAME]
		oObject.s_ObjectClass = fvRawObject [raw_OBJECT_CLASS]
		# oObject.i_ObjectClass = map_ObjectClassToIndex.get (oObject.s_ObjectClass, None)

		oObject.s_CleanName = rgx_NonAlnum.sub (' ', oObject.s_Name)
		oObject.s_CleanName = rgx_Whitespace.sub (' ', oObject.s_CleanName)

		#print '  ', oObject.s_ID, oObject.s_ObjectClass, oObject.s_Name
		if oObject.s_Name in sLine:
			lstObjects.append (oObject)
			break

	#return lstObjects
	return sResponse




#																	
def send_action (_sCommand):
	global lstObjects

	sObjectID = None
	if 1 == len (lstObjects):
		sObjectID = lstObjects [0].s_ID
		# print 'object id : ', sObjectID
	else:
		print lstObjects
		assert False
	lstObjects = []

	sCommand = '!' + sObjectID + ':' + _sCommand.split (':', 1)[-1]
	# print 'command : ', sCommand
	#print sCommand

	soc_Client.send (sCommand + '\n')
	sResponse = ''
	while '\x10' not in sResponse:
		sResponse = sResponse + soc_Client.recv (1024)


	if '[ERROR]' in sResponse:
		print '[WARNING] Error response received from OS agent.'
		print 'command ->' + sCommand + '<-'
		print 'response:'
		print '---------------------------------------------'
		print sResponse
		print '---------------------------------------------'

		sInput = raw_input ('continue? [y/n] :')
		if 'n' == sInput.strip ():
			sys.exit ()

	return ('env has changed' in sResponse)



#																	
def clear_connection ():

	soc_Client.settimeout (None)
	#soc_Client.send ('\n')
	time.sleep (1)
	sResponse = ' '
	try:
		while '' != sResponse:
			sResponse = soc_Client.recv (1024, socket.MSG_DONTWAIT)
	except socket.error:
		e = sys.exc_info()[1]
		soc_Client.settimeout (120)
		if 11 != e[0]:
			raise

	if len (sResponse) > 0:
		print "   " + str (len (sResponse)) + " bytes cleared from socket connection."
	else:
		print '   socket connection clear.'
	soc_Client.settimeout (120)




#																	
def main ():
	global soc_Client

	sIP = sys.argv [1]
	iPort = int (sys.argv [2])
	sFileName = sys.argv [3]

	file = open (sFileName)
	lstLines = map (lambda x: x.strip (), file.readlines ())
	file.close ()

	soc_Client = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
	soc_Client.setsockopt (socket.IPPROTO_TCP, socket.TCP_NODELAY, 1);
	soc_Client.connect ((sIP, iPort))
	# clear_connection ()
	#print '=========================='

	for sLine in lstLines:
		if '' == sLine:
			continue
		if 'exit' == sLine:
			return

		if '#' == sLine [0]:
			#print
			#print '-----------------------------------'
			continue

		print sLine


		if sLine [0] in '?*':
			response = measure_state (sLine)
			if '**' == sLine:
				print response
			print response
			#print '---'
			#time.sleep (1)

		elif '!' == sLine [0]:
			#send_action (sLine)
			soc_Client.send (sLine + '\n')
			sResponse = ''
			while '\x10' not in sResponse:
				sResponse = sResponse + soc_Client.recv (1024)
			print sResponse
			#print '---'
			#time.sleep (1)

		elif '>' == sLine [0]:
			soc_Client.send (sLine + '\n')
			sResponse = ''
			while '\x10' not in sResponse:
				sResponse = sResponse + soc_Client.recv (1024)
			print sResponse
			#print '---'
			#time.sleep (1)

		elif '.' == sLine [0]:
			soc_Client.send (sLine + '\n')
			#print '---'
			#time.sleep (1)


		else:
			print '->' + sLine + '<-'
			assert False




if __name__ == '__main__':
	sys.exit (main ())
