import sys, os, socket, time, re, select


soc_Client = None


#																	
def main ():
	global soc_Client

	if len (sys.argv) < 3:
		print '[agent port] [reset port] [test file]'
		return

	iPort = int (sys.argv [1])
	iPortVM = int (sys.argv [2])
	sFileName = sys.argv [3]

	file = open (sFileName)
	lst_Lines = filter (lambda x: '' != x.strip (), file.readlines ())
	file.close ()
	i_CurrentLine = 0

	soc_Server = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
	soc_Server.setblocking (0)
	soc_Server.bind (('', iPort))
	soc_Server.listen (2)

	soc_ServerVM = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
	soc_ServerVM.setblocking (0)
	soc_ServerVM.bind (('', iPortVM))
	soc_ServerVM.listen (2)

	soc_Client = None
	soc_VM = None

	b_ClientConnected = False
	b_VMConnected = False
	s_DataToSend = ''
	s_DataReceived = ''


	while True:
		# accept incoming connections.	
		lstReadReady = []
		lstWriteReady = []
		lstInError = []
	
		lstToWrite = []
		if '' != s_DataToSend:
			lstToWrite = [soc_Client]
		if (True == b_ClientConnected) and (True == b_VMConnected):
			lstReadReady, lstWriteReady, lstInError =\
					select.select ([soc_Server, soc_ServerVM, soc_Client, soc_VM], 
									lstToWrite,
									[soc_Server, soc_ServerVM, soc_Client, soc_VM], 1)
		else:
			lstReadReady, lstWriteReady, lstInError =\
					select.select ([soc_Server, soc_ServerVM], lstToWrite, [soc_Server, soc_ServerVM], 1)


		# check for errors.				
		if soc_Client in lstInError:
			soc_Client.close ()
			soc_Client = None
			b_ClientConnected = False
		if soc_VM in lstInError:
			soc_VM.close ()
			soc_VM = None
			b_VMConnected = False
		if soc_Server in lstInError:
			soc_Server.close ()
			soc_Server = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
			soc_Server.setblocking (0)
			soc_Server.bind (('', iPort))
			soc_Server.listen (2)
		if soc_ServerVM in lstInError:
			soc_ServerVM.close ()
			soc_ServerVM = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
			soc_ServerVM.setblocking (0)
			soc_ServerVM.bind (('', iPortVM))
			soc_ServerVM.listen (2)


		# check for reads.				
		if soc_Server in lstReadReady:
			if False == b_ClientConnected:
				(soc_Client, address) = soc_Server.accept ()
				soc_Client.setblocking (0)
				b_ClientConnected = True
				print 'connected from: ' + str(address)

		if soc_ServerVM in lstReadReady:
			if False == b_VMConnected:
				(soc_VM, address) = soc_ServerVM.accept ()
				soc_VM.setblocking (0)
				b_VMConnected = True
				print 'vm connected from: ' + str(address)


		if soc_Client in lstReadReady:
			data = soc_Client.recv (8192)
			if (None == data) or ('' == data):
				soc_Client.close ()
				soc_Client = None
				b_ClientConnected = False
			else:
				s_DataReceived += data

		elif soc_VM in lstReadReady:
			data = soc_VM.recv (8192)
			if (None == data) or ('' == data):
				soc_VM.close ()
				soc_VM = None
				b_VMConnected = False
			else:
				s_DataReceived += data


		if '\n' in s_DataReceived:
			if s_DataReceived != lst_Lines [i_CurrentLine]:
				print '->' + s_DataReceived + '<-'
				print '->' + lst_Lines [i_CurrentLine] + '<-'
				assert False

			print 'received : (' + s_DataReceived + ')'
			s_DataReceived = ''
			i_CurrentLine += 1
			if i_CurrentLine > len (lst_Lines):
				return
			while i_CurrentLine < len (lst_Lines):
				s_DataToSend += lst_Lines [i_CurrentLine]
				i_CurrentLine += 1
				if '\x10' in s_DataToSend:
					break
			if i_CurrentLine > len (lst_Lines):
				return

		if '{exit}\x10\n' == s_DataToSend:
			print '============================================='
			print ' Quitting on {exit} command'
			print '============================================='
			return
		if '{skip}\x10\n' == s_DataToSend:
			s_DataToSend = ''
		if '{pause}\x10\n' == s_DataToSend:
			time.sleep (5)
			s_DataToSend += lst_Lines [i_CurrentLine]
			i_CurrentLine += 1

		if (soc_Client in lstWriteReady) and ('' != s_DataToSend):
			print 'sending : (' + s_DataToSend + ')'
			time.sleep (1)
			soc_Client.send (s_DataToSend)
			s_DataToSend = ''

	soc_Server.close ()
	soc_ServerVM.close ()
	soc_Client.close ()
	soc_VM.close ()



if __name__ == '__main__':
	sys.exit (main ())
